set ns [new Simulator]
$ns color 1 Blue
$ns color 2 Red
set fd [open test.tr w]
$ns trace-all $fd
set nf [open out.nam w]
$ns namtrace-all $nf
set f0 [open n0.tr w]
set f1 [open n1.tr w]
set f3 [open n3.tr w]


set n0 [$ns node]
set n1 [$ns node]
set n2 [$ns node]
set n3 [$ns node]

#$ns trace-$n0 $f0
#$ns trace-$n1 $f1
#$ns trace-$n3 $f3

proc finish {} {
global ns fd nf f0 f1
$ns flush-trace
close $fd
close $nf
close $f0
close $f1
exec nam out.nam &
exit 0
}

#proc record {} {
#global n0 n1 n2 n3 f0 f1
#set ns [Simulator instance]
#set time 0.05
#set now [$ns now]
#set a [$n0 set bytes_]
#set b [$n1 set bytes_]
#set c [$n3 set bytes_]
#puts f0 "$now [expr ($a+$b)*8/$time]"
#puts f1 "$now [expr $c*8/$time]"
#$ns at [expr $now+$time] "record" 
#}

#create node

$ns duplex-link $n0 $n2 10Mb 5ms DropTail
$ns duplex-link $n1 $n2 10Mb 5ms DropTail
$ns duplex-link $n2 $n3 2Mb 5ms DropTail

#create a udp agent and attach to node n0

set udp [new Agent/UDP]
$ns attach-agent $n0 $udp
set udp1 [new Agent/UDP]
$ns attach-agent $n1 $udp1
set udp2 [new Agent/UDP]
$ns attach-agent $n2 $udp2

#setup a CBR over UDP connection
set cbr0 [new Application/Traffic/CBR]
$cbr0 set packetSize_ 1000
$cbr0 set interval_ 0.005
$cbr0 attach-agent $udp


#setup a CBR over UDP connection
set cbr1 [new Application/Traffic/CBR]
$cbr1 set packetSize_ 1000
$cbr1 set interval_ 0.005
$cbr1 attach-agent $udp1

#create a null agent and attach to node n1
set null [new Agent/Null]
$ns attach-agent $n3 $null


set loss [new Agent/LossMonitor]
$ns connect $udp2 $loss

$ns connect $udp $null
$ns connect $udp1 $null

$udp set fid_ 1
$udp1 set fid_ 2

#sechdule events for cbr agent
#$ns at 0.0 "record"
$ns at 0.0 "$cbr0 start"
$ns at 2.5 "$cbr0 stop"
$ns at 0.5 "$cbr1 start"
$ns at 2.5 "$cbr1 stop"
$ns at 5.0 "finish"


#run the siulation
$ns run
 
